#(C) Copyright International Business Machines  Corp., 2011-2019
%define sles %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define rhel %(test -e /etc/redhat-release && echo 1 || echo 0)
%define sles12 %(test -e /etc/SuSE-release && cat /etc/SuSE-release | grep VERSION | grep 12 >/dev/null && echo 1 || echo 0)
%define sles15 %(test -e /etc/os-release && cat /etc/os-release | grep VERSION | grep 15 >/dev/null && echo 1 || echo 0)
%define ubuntu %(test -e /etc/os-release && grep -qi Ubuntu /etc/os-release && echo 1 || echo 0)
%bcond_with sfmp

Summary: IBM Tape SCSI Device Driver for Linux
Name: lin_tape
Version: 3.0.46
Release: 1
License: GPL
Vendor: IBM
Group: System Environment/Kernel
Source: %{name}-%{version}.tgz
# this is the build root suggested by redhat
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
AutoReqProv: no
%if ! %{ubuntu}
%if %{sles}
BuildRequires: kernel-source
%endif
%if %{sles12} || %{sles15}
BuildRequires: libstdc++6
%else
BuildRequires: libstdc++
%endif
%if %{rhel}
BuildRequires: kernel-devel rpm-build
%endif
BuildRequires: glibc-devel gcc make bzip2
%endif
Obsoletes: IBMtape
Conflicts: IBMtape lin_tape < %{version}
Packager: IBM Tape SCSI Device Driver Development

%undefine _enable_debug_packages

%define debug_package %{nil}

%define KERNEL %( echo ${KERNEL:-%(uname -r)})
%define KERNELTYPES default smp bigsmp hugemem
%define TOSTILE() %(echo %1|tr ' ' '|')
%define KERNELBASENAME %(echo %{KERNEL}|sed --regexp-extended -e 's/[^a-zA-Z0-9]*(%{TOSTILE %KERNELTYPES})*$//p;d')
%define KERNELSPRESENT %KERNEL
%define DISTRO %( cat /etc/redflag-release 2>/dev/null| cat - /etc/redhat-release 2>/dev/null| cat - /etc/SuSE-release 2>/dev/null| head -1 2>/dev/null)

%description
%( echo "The IBM Tape Device Driver, lin_tape, provides attachment and advance functionality for use with IBM and other vendor tape devices to Linux compatible platforms."| tr '\n' ' ' | fold -s -w 65 )
%prep
%setup -q

%build
%if %{ubuntu}
make KERNEL=%{KERNEL} SFMP=%{with sfmp} driver
%else
p=`echo $MACHTYPE|cut -f 1 -d '-'`
( [ $p == "i386" ] || [ $p == "i586" ] || [ $p == "i686" ] ) && proc="Intel"
( [ $p == "ppc64" ] || [ $p == "powerpc" ] || [ $p == "powerpc64" ]) && proc="pSeries"
( [ $p == "s390" ] ) && proc="zSeries"
( [ $p == "s390x" ] ) && proc="zSeries"
( [ $p == "ia64" ] ) && proc="Intel"
( [ $p == "x86_64" ] ) && proc="AMD"
make KERNEL=%{KERNEL} PROC=$p SFMP=%{with sfmp} driver
%endif

%install
rm -rf $RPM_BUILD_ROOT
%( for f in %{KERNELSPRESENT}; do echo "install -D -m 644 bldtmp/pfo-$f.ko \$RPM_BUILD_ROOT/lib/modules/$f/kernel/drivers/scsi/pfo.ko"; done)
%( for f in %{KERNELSPRESENT}; do echo "install -D -m 644 bldtmp/lin_tape-$f.ko \$RPM_BUILD_ROOT/lib/modules/$f/kernel/drivers/scsi/lin_tape.ko"; done)
%if %{with sfmp}
%( for f in %{KERNELSPRESENT}; do echo "install -D -m 644 bldtmp/sgmp-$f.ko \$RPM_BUILD_ROOT/lib/modules/$f/kernel/drivers/scsi/sgmp.ko"; done)
%( for f in %{KERNELSPRESENT}; do echo "install -D -m 644 bldtmp/stmp-$f.ko \$RPM_BUILD_ROOT/lib/modules/$f/kernel/drivers/scsi/stmp.ko"; done)
%endif
install -D -m 755 "lin_tape" $RPM_BUILD_ROOT/usr/sbin/lin_tape
install -D -m 666 "IBM_tape.h" $RPM_BUILD_ROOT/usr/include/sys/IBM_tape.h
install -D -m 0644 "lin_tape.service" $RPM_BUILD_ROOT/usr/lib/systemd/system/lin_tape.service
cd $RPM_BUILD_ROOT
cd -

%pre
# if not kernel %{KERNEL}, exit the install
KERNEL=`uname -r`
if [ `echo \`echo /lib/modules/*|tr ' ' '\n'|rev|cut -f 1 -d '/'|rev\` %{KERNELSPRESENT}|tr ' ' '\n'|sort|uniq -d|wc|cut -b 1-7` -eq 0 ] ; then
  cat <<EOF
 %( echo "The current install of lin_tape supports Kernel(s) %{KERNELSPRESENT} only. None of these kernels are present. Exiting the installation."|fold -s -w 65)
EOF
  exit 100
fi
# If this will be the 2nd (or more) copies of the driver on the system
# remove the system initialization code
if [[ "$1" > 1 ]]; then
  [ -x /usr/sbin/lin_tape ] && /usr/sbin/lin_tape stop || true
fi

%post
# software is on the system, now configure it and kick it off
depmod -a
systemctl daemon-reload
systemctl start lin_tape.service
systemctl enable lin_tape.service
echo lin_tape loaded

%preun
#we need to check if this is a rpm -e or rpm -U command
if [[ "$1" == "0" ]]; then
  # 0 copies will be left after this -e or -U command therefore we
  # need to shut down the daemon and remove the initialization links
  [ -x /usr/sbin/lin_tape ] && systemctl stop lin_tape.service && systemctl disable lin_tape.service || true
fi

%postun
depmod -a
[ -x /usr/lib/systemd/system/lin_tape.service ] && rm /usr/lib/systemd/system/lin_tape.service && systemctl daemon-reload && systemctl reset-failed || true
[ -x /usr/sbin/lin_tape ] && rm /usr/sbin/lin_tape || true

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc lin_tape.ReadMe lin_tape_daemon.ReadMe COPYING COPYING.LIB
%( for f in %{KERNELSPRESENT}; do echo "/lib/modules/$f/kernel/drivers/scsi/pfo.ko"; done)
%( for f in %{KERNELSPRESENT}; do echo "/lib/modules/$f/kernel/drivers/scsi/lin_tape.ko"; done)
%if %{with sfmp}
%( for f in %{KERNELSPRESENT}; do echo "/lib/modules/$f/kernel/drivers/scsi/sgmp.ko"; done)
%( for f in %{KERNELSPRESENT}; do echo "/lib/modules/$f/kernel/drivers/scsi/stmp.ko"; done)
%endif
%attr(0755,root,root) /usr/sbin/lin_tape
%attr(0666,root,root) /usr/include/sys/IBM_tape.h
%attr(0644,root,root) /usr/lib/systemd/system/lin_tape.service

%changelog
* Mon Jun 10 2019 IBM Corporation
- Removed init.d
* Fri Feb 26 2016 IBM Corporation
- Adding join driver
* Wed Jan 31 2007 IBM Corporation
- Redesign the build system to no longer require autoconf. It is significantly cleaner and versatile.  'rpmbuild -tb ...' works, as does 'make rpm', as does sticking the source directory into the kernel source, as does rpmbuild -bb (after doing an install of the source)

